#ifndef lint
static	char	sccsid[] = "@(#)sd.hp.c 	1.2  4/17/85";
#endif
#include	<rasterfile.h>
#include	<stdio.h>
#include	<signal.h>
#include	<sys/file.h>

/*
 *	this is a filter for laserjet printers. this
 *	expects to be fed by something like screendump
 *	use a printcap entry like:
 * tjhpbit|hpbit:\
 *	:br#9600:lp=/dev/ttyb:fs#06021:of=/usr/lib/sd.hp:\
 *	:lf=/usr/adm/lpd-errs:fc:#0777:sb:sh:pl#60:xc#07737:xs#040:sf:
 *	everything read will be copied to stdout till the 
 *	magic number for a rasterfile is encountered, then
 *	it will do its things. tabs are also esxpanded correctly
 */

main(argc,argv)
int argc;
int *argv[];
{
	struct	rasterfile	r;
	int	i,j,k,l,m,n,col;
	char	*q,*p[8], send[32], c, *malloc();
	char	buffer[BUFSIZ*4];
	flock(fileno(stdout), LOCK_EX);
	setbuffer(stdout, buffer, BUFSIZ*4);
	while(1 == 1) {
		printf("\033&l0O");
		printf("\033(8U");
		printf("\033(s0p16.66h8.5v0s0b0T");
		printf("\033&k3G");
		printf("\033&a13L");
		fflush(stdout);
		for(m=RAS_MAGIC, q=(char *) &m,i=col=0; i < sizeof(m);) {
			if(((n = getchar()) & 0xff) == (q[i] & 0xff)) {
				i++;
				continue;
				}
			if(n == EOF && feof(stdin)) {
				fflush(stdout);
				fclose(stdout);
				exit(0);
				}
			if(i)
				putchar(q[i=0]);
			switch(n) {
				case '\t':
					for(i=8-(col%8); i; i--)
						putchar(' ');
					col = 0;
					break;
				case '\r':
				case '\n':
				case '\f':
					col = 0;
					putchar(n);
				case '\033':
					break;
				default:
					putchar(n);
					col++;
				}
			}
		j = sizeof(r) - sizeof(int);
		q = (char *) &r;
		if(fread(q + sizeof(int), j, 1, stdin) != 1) {
			perror("mishap");
			exit(1);
			}
			/* get extar bits per line */
		k = ((((r.ras_width + 15) / 16) * 16) - r.ras_width);
	if(k>7) {
			k -= 8;
			l = 1;
			}
		else
			l = 0;
		printf("\033*t150R");	/* 100 DPI  */
		printf("\033&k1H"); 	/* horiz spacing */
#define	SPACE_OVER	11	/* 11*8 = 72 pixel ~ .75 inch */
		for(i=0 ; i < r.ras_height ; i++) {
			printf("\033*r0A");
			printf("\033*b%dW",((r.ras_width + k)/8) + SPACE_OVER);

			for(j=0 ; j < SPACE_OVER; j++)
				putchar(0);
			for(j=0 ; j < (r.ras_width/8); j++)
				if((n = getchar()) == EOF && feof(stdin))
					exit(0);  /* throw away a byte */
				else
					putchar(n);
			if(k)
				if((n = getchar()) == EOF && feof(stdin))
					exit(0);  /* throw away a byte */
				else
					putchar(n & (0xff << (k-1)));
				/* zero unwanted bits */
				if(l) {
					if((n = getchar()) == EOF && feof(stdin))
						exit(0);  /* throw away a byte */
					if(!k)
					putchar(n);
					}
			printf("\033*rB");    /* Stop raster */
			printf("\033&a0H");   /* horiz 0 */
			}
		printf("\f");
		fflush(stdout);
	}
}
sigTERM()
{
	printf("\f");
	printf("\033E");
	fflush(stdout);
	exit(0);
}
